workflow:
  rules:
    # don't create a pipeline if its a commit pipeline, on a branch and that branch has open merge requests (bc we will get a MR build instead)
    - if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - when: always

image:
  # Allow download only light on Free runners 
  name: hashicorp/terraform:light
  # Bug fix, "Terraform has no command named "sh"."  
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

variables:
  AWS_ACCESS_KEY_ID: ${AWS_ACCESS_KEY_ID}
  AWS_SECRET_ACCESS_KEY: ${AWS_SECRET_ACCESS_KEY}

include:
  # INIT
  - local: 'aws-eks/stages/init/core/.terraform_init.yaml'
  - local: 'aws-eks/stages/init/.terraform_init_main.yaml'
  
  # PLAN
  - local: 'aws-eks/stages/plan/core/.terraform_plan.yaml'
  - local: 'aws-eks/stages/plan/.terraform_plan_main.yaml'

  # APPLY
  - local: 'aws-eks/stages/apply/core/.terraform_apply.yaml'
  - local: 'aws-eks/stages/apply/.terraform_apply_main.yaml'
  
  # DESTROY
  - local: 'aws-eks/stages/destroy/core/.terraform_destroy.yaml'
  - local: 'aws-eks/stages/destroy/terraform_destroy_main.yaml'
  
stages:
  - terraform_init
  - terraform_plan
  - terraform_apply
  - terraform_destroy
